//------------------------------------------------------------------------------
// PySyntaxBindings0.cpp
// Generated Python bindings for syntax types
//
// SPDX-FileCopyrightText: Michael Popoloski
// SPDX-License-Identifier: MIT
//------------------------------------------------------------------------------
#include "pyslang.h"

#include "slang/syntax/AllSyntax.h"

void registerSyntaxNodes0(py::module_& m) {
    py::class_<ExpressionSyntax, SyntaxNode>(m, "ExpressionSyntax");

    py::class_<DataTypeSyntax, ExpressionSyntax>(m, "DataTypeSyntax");

    py::class_<TimingControlSyntax, SyntaxNode>(m, "TimingControlSyntax");

    py::class_<SequenceExprSyntax, SyntaxNode>(m, "SequenceExprSyntax");

    py::class_<PropertyExprSyntax, SyntaxNode>(m, "PropertyExprSyntax");

    py::class_<EqualsValueClauseSyntax, SyntaxNode>(m, "EqualsValueClauseSyntax")
        .def_readwrite("equals", &EqualsValueClauseSyntax::equals)
        .def_readwrite("expr", &EqualsValueClauseSyntax::expr);

    py::class_<AttributeSpecSyntax, SyntaxNode>(m, "AttributeSpecSyntax")
        .def_readwrite("name", &AttributeSpecSyntax::name)
        .def_readwrite("value", &AttributeSpecSyntax::value);

    py::class_<AttributeInstanceSyntax, SyntaxNode>(m, "AttributeInstanceSyntax")
        .def_readwrite("openParen", &AttributeInstanceSyntax::openParen)
        .def_readwrite("openStar", &AttributeInstanceSyntax::openStar)
        .def_readwrite("specs", &AttributeInstanceSyntax::specs)
        .def_readwrite("closeStar", &AttributeInstanceSyntax::closeStar)
        .def_readwrite("closeParen", &AttributeInstanceSyntax::closeParen);

    py::class_<NamedLabelSyntax, SyntaxNode>(m, "NamedLabelSyntax")
        .def_readwrite("name", &NamedLabelSyntax::name)
        .def_readwrite("colon", &NamedLabelSyntax::colon);

    py::class_<StatementSyntax, SyntaxNode>(m, "StatementSyntax")
        .def_readwrite("label", &StatementSyntax::label)
        .def_readwrite("attributes", &StatementSyntax::attributes);

    py::class_<MemberSyntax, SyntaxNode>(m, "MemberSyntax")
        .def_readwrite("attributes", &MemberSyntax::attributes);

    py::class_<ArgumentSyntax, SyntaxNode>(m, "ArgumentSyntax");

    py::class_<EmptyArgumentSyntax, ArgumentSyntax>(m, "EmptyArgumentSyntax")
        .def_readwrite("placeholder", &EmptyArgumentSyntax::placeholder);

    py::class_<OrderedArgumentSyntax, ArgumentSyntax>(m, "OrderedArgumentSyntax")
        .def_readwrite("expr", &OrderedArgumentSyntax::expr);

    py::class_<NamedArgumentSyntax, ArgumentSyntax>(m, "NamedArgumentSyntax")
        .def_readwrite("dot", &NamedArgumentSyntax::dot)
        .def_readwrite("name", &NamedArgumentSyntax::name)
        .def_readwrite("openParen", &NamedArgumentSyntax::openParen)
        .def_readwrite("expr", &NamedArgumentSyntax::expr)
        .def_readwrite("closeParen", &NamedArgumentSyntax::closeParen);

    py::class_<ArgumentListSyntax, SyntaxNode>(m, "ArgumentListSyntax")
        .def_readwrite("openParen", &ArgumentListSyntax::openParen)
        .def_readwrite("parameters", &ArgumentListSyntax::parameters)
        .def_readwrite("closeParen", &ArgumentListSyntax::closeParen);

    py::class_<ParamAssignmentSyntax, SyntaxNode>(m, "ParamAssignmentSyntax");

    py::class_<OrderedParamAssignmentSyntax, ParamAssignmentSyntax>(m, "OrderedParamAssignmentSyntax")
        .def_readwrite("expr", &OrderedParamAssignmentSyntax::expr);

    py::class_<NamedParamAssignmentSyntax, ParamAssignmentSyntax>(m, "NamedParamAssignmentSyntax")
        .def_readwrite("dot", &NamedParamAssignmentSyntax::dot)
        .def_readwrite("name", &NamedParamAssignmentSyntax::name)
        .def_readwrite("openParen", &NamedParamAssignmentSyntax::openParen)
        .def_readwrite("expr", &NamedParamAssignmentSyntax::expr)
        .def_readwrite("closeParen", &NamedParamAssignmentSyntax::closeParen);

    py::class_<ParameterValueAssignmentSyntax, SyntaxNode>(m, "ParameterValueAssignmentSyntax")
        .def_readwrite("hash", &ParameterValueAssignmentSyntax::hash)
        .def_readwrite("openParen", &ParameterValueAssignmentSyntax::openParen)
        .def_readwrite("parameters", &ParameterValueAssignmentSyntax::parameters)
        .def_readwrite("closeParen", &ParameterValueAssignmentSyntax::closeParen);

    py::class_<PatternSyntax, SyntaxNode>(m, "PatternSyntax");

    py::class_<ParenthesizedPatternSyntax, PatternSyntax>(m, "ParenthesizedPatternSyntax")
        .def_readwrite("openParen", &ParenthesizedPatternSyntax::openParen)
        .def_readwrite("pattern", &ParenthesizedPatternSyntax::pattern)
        .def_readwrite("closeParen", &ParenthesizedPatternSyntax::closeParen);

    py::class_<VariablePatternSyntax, PatternSyntax>(m, "VariablePatternSyntax")
        .def_readwrite("dot", &VariablePatternSyntax::dot)
        .def_readwrite("variableName", &VariablePatternSyntax::variableName);

    py::class_<WildcardPatternSyntax, PatternSyntax>(m, "WildcardPatternSyntax")
        .def_readwrite("dot", &WildcardPatternSyntax::dot)
        .def_readwrite("star", &WildcardPatternSyntax::star);

    py::class_<ExpressionPatternSyntax, PatternSyntax>(m, "ExpressionPatternSyntax")
        .def_readwrite("expr", &ExpressionPatternSyntax::expr);

    py::class_<TaggedPatternSyntax, PatternSyntax>(m, "TaggedPatternSyntax")
        .def_readwrite("tagged", &TaggedPatternSyntax::tagged)
        .def_readwrite("memberName", &TaggedPatternSyntax::memberName)
        .def_readwrite("pattern", &TaggedPatternSyntax::pattern);

    py::class_<StructurePatternMemberSyntax, SyntaxNode>(m, "StructurePatternMemberSyntax");

    py::class_<OrderedStructurePatternMemberSyntax, StructurePatternMemberSyntax>(m, "OrderedStructurePatternMemberSyntax")
        .def_readwrite("pattern", &OrderedStructurePatternMemberSyntax::pattern);

    py::class_<NamedStructurePatternMemberSyntax, StructurePatternMemberSyntax>(m, "NamedStructurePatternMemberSyntax")
        .def_readwrite("name", &NamedStructurePatternMemberSyntax::name)
        .def_readwrite("colon", &NamedStructurePatternMemberSyntax::colon)
        .def_readwrite("pattern", &NamedStructurePatternMemberSyntax::pattern);

    py::class_<StructurePatternSyntax, PatternSyntax>(m, "StructurePatternSyntax")
        .def_readwrite("openBrace", &StructurePatternSyntax::openBrace)
        .def_readwrite("members", &StructurePatternSyntax::members)
        .def_readwrite("closeBrace", &StructurePatternSyntax::closeBrace);

    py::class_<MatchesClauseSyntax, SyntaxNode>(m, "MatchesClauseSyntax")
        .def_readwrite("matchesKeyword", &MatchesClauseSyntax::matchesKeyword)
        .def_readwrite("pattern", &MatchesClauseSyntax::pattern);

    py::class_<ConditionalPatternSyntax, SyntaxNode>(m, "ConditionalPatternSyntax")
        .def_readwrite("expr", &ConditionalPatternSyntax::expr)
        .def_readwrite("matchesClause", &ConditionalPatternSyntax::matchesClause);

    py::class_<ConditionalPredicateSyntax, SyntaxNode>(m, "ConditionalPredicateSyntax")
        .def_readwrite("conditions", &ConditionalPredicateSyntax::conditions);

    py::class_<AssignmentPatternSyntax, SyntaxNode>(m, "AssignmentPatternSyntax");

    py::class_<SimpleAssignmentPatternSyntax, AssignmentPatternSyntax>(m, "SimpleAssignmentPatternSyntax")
        .def_readwrite("openBrace", &SimpleAssignmentPatternSyntax::openBrace)
        .def_readwrite("items", &SimpleAssignmentPatternSyntax::items)
        .def_readwrite("closeBrace", &SimpleAssignmentPatternSyntax::closeBrace);

    py::class_<AssignmentPatternItemSyntax, SyntaxNode>(m, "AssignmentPatternItemSyntax")
        .def_readwrite("key", &AssignmentPatternItemSyntax::key)
        .def_readwrite("colon", &AssignmentPatternItemSyntax::colon)
        .def_readwrite("expr", &AssignmentPatternItemSyntax::expr);

    py::class_<StructuredAssignmentPatternSyntax, AssignmentPatternSyntax>(m, "StructuredAssignmentPatternSyntax")
        .def_readwrite("openBrace", &StructuredAssignmentPatternSyntax::openBrace)
        .def_readwrite("items", &StructuredAssignmentPatternSyntax::items)
        .def_readwrite("closeBrace", &StructuredAssignmentPatternSyntax::closeBrace);

    py::class_<ReplicatedAssignmentPatternSyntax, AssignmentPatternSyntax>(m, "ReplicatedAssignmentPatternSyntax")
        .def_readwrite("openBrace", &ReplicatedAssignmentPatternSyntax::openBrace)
        .def_readwrite("countExpr", &ReplicatedAssignmentPatternSyntax::countExpr)
        .def_readwrite("innerOpenBrace", &ReplicatedAssignmentPatternSyntax::innerOpenBrace)
        .def_readwrite("items", &ReplicatedAssignmentPatternSyntax::items)
        .def_readwrite("innerCloseBrace", &ReplicatedAssignmentPatternSyntax::innerCloseBrace)
        .def_readwrite("closeBrace", &ReplicatedAssignmentPatternSyntax::closeBrace);

    py::class_<BadExpressionSyntax, ExpressionSyntax>(m, "BadExpressionSyntax")
        .def_readwrite("expr", &BadExpressionSyntax::expr);

    py::class_<PrimaryExpressionSyntax, ExpressionSyntax>(m, "PrimaryExpressionSyntax");

    py::class_<PrefixUnaryExpressionSyntax, ExpressionSyntax>(m, "PrefixUnaryExpressionSyntax")
        .def_readwrite("operatorToken", &PrefixUnaryExpressionSyntax::operatorToken)
        .def_readwrite("attributes", &PrefixUnaryExpressionSyntax::attributes)
        .def_readwrite("operand", &PrefixUnaryExpressionSyntax::operand);

    py::class_<PostfixUnaryExpressionSyntax, ExpressionSyntax>(m, "PostfixUnaryExpressionSyntax")
        .def_readwrite("operand", &PostfixUnaryExpressionSyntax::operand)
        .def_readwrite("attributes", &PostfixUnaryExpressionSyntax::attributes)
        .def_readwrite("operatorToken", &PostfixUnaryExpressionSyntax::operatorToken);

    py::class_<BinaryExpressionSyntax, ExpressionSyntax>(m, "BinaryExpressionSyntax")
        .def_readwrite("left", &BinaryExpressionSyntax::left)
        .def_readwrite("operatorToken", &BinaryExpressionSyntax::operatorToken)
        .def_readwrite("attributes", &BinaryExpressionSyntax::attributes)
        .def_readwrite("right", &BinaryExpressionSyntax::right);

    py::class_<MinTypMaxExpressionSyntax, ExpressionSyntax>(m, "MinTypMaxExpressionSyntax")
        .def_readwrite("min", &MinTypMaxExpressionSyntax::min)
        .def_readwrite("colon1", &MinTypMaxExpressionSyntax::colon1)
        .def_readwrite("typ", &MinTypMaxExpressionSyntax::typ)
        .def_readwrite("colon2", &MinTypMaxExpressionSyntax::colon2)
        .def_readwrite("max", &MinTypMaxExpressionSyntax::max);

    py::class_<TaggedUnionExpressionSyntax, ExpressionSyntax>(m, "TaggedUnionExpressionSyntax")
        .def_readwrite("tagged", &TaggedUnionExpressionSyntax::tagged)
        .def_readwrite("member", &TaggedUnionExpressionSyntax::member)
        .def_readwrite("expr", &TaggedUnionExpressionSyntax::expr);

    py::class_<ValueRangeExpressionSyntax, ExpressionSyntax>(m, "ValueRangeExpressionSyntax")
        .def_readwrite("openBracket", &ValueRangeExpressionSyntax::openBracket)
        .def_readwrite("left", &ValueRangeExpressionSyntax::left)
        .def_readwrite("op", &ValueRangeExpressionSyntax::op)
        .def_readwrite("right", &ValueRangeExpressionSyntax::right)
        .def_readwrite("closeBracket", &ValueRangeExpressionSyntax::closeBracket);

    py::class_<RangeListSyntax, SyntaxNode>(m, "RangeListSyntax")
        .def_readwrite("openBrace", &RangeListSyntax::openBrace)
        .def_readwrite("valueRanges", &RangeListSyntax::valueRanges)
        .def_readwrite("closeBrace", &RangeListSyntax::closeBrace);

    py::class_<InsideExpressionSyntax, ExpressionSyntax>(m, "InsideExpressionSyntax")
        .def_readwrite("expr", &InsideExpressionSyntax::expr)
        .def_readwrite("inside", &InsideExpressionSyntax::inside)
        .def_readwrite("ranges", &InsideExpressionSyntax::ranges);

    py::class_<ConditionalExpressionSyntax, ExpressionSyntax>(m, "ConditionalExpressionSyntax")
        .def_readwrite("predicate", &ConditionalExpressionSyntax::predicate)
        .def_readwrite("question", &ConditionalExpressionSyntax::question)
        .def_readwrite("attributes", &ConditionalExpressionSyntax::attributes)
        .def_readwrite("left", &ConditionalExpressionSyntax::left)
        .def_readwrite("colon", &ConditionalExpressionSyntax::colon)
        .def_readwrite("right", &ConditionalExpressionSyntax::right);

    py::class_<AssignmentPatternExpressionSyntax, PrimaryExpressionSyntax>(m, "AssignmentPatternExpressionSyntax")
        .def_readwrite("type", &AssignmentPatternExpressionSyntax::type)
        .def_readwrite("pattern", &AssignmentPatternExpressionSyntax::pattern);

    py::class_<SelectorSyntax, SyntaxNode>(m, "SelectorSyntax");

    py::class_<BitSelectSyntax, SelectorSyntax>(m, "BitSelectSyntax")
        .def_readwrite("expr", &BitSelectSyntax::expr);

    py::class_<RangeSelectSyntax, SelectorSyntax>(m, "RangeSelectSyntax")
        .def_readwrite("left", &RangeSelectSyntax::left)
        .def_readwrite("range", &RangeSelectSyntax::range)
        .def_readwrite("right", &RangeSelectSyntax::right);

    py::class_<ElementSelectSyntax, SyntaxNode>(m, "ElementSelectSyntax")
        .def_readwrite("openBracket", &ElementSelectSyntax::openBracket)
        .def_readwrite("selector", &ElementSelectSyntax::selector)
        .def_readwrite("closeBracket", &ElementSelectSyntax::closeBracket);

    py::class_<NameSyntax, ExpressionSyntax>(m, "NameSyntax");

    py::class_<IdentifierNameSyntax, NameSyntax>(m, "IdentifierNameSyntax")
        .def_readwrite("identifier", &IdentifierNameSyntax::identifier);

    py::class_<SystemNameSyntax, NameSyntax>(m, "SystemNameSyntax")
        .def_readwrite("systemIdentifier", &SystemNameSyntax::systemIdentifier);

    py::class_<IdentifierSelectNameSyntax, NameSyntax>(m, "IdentifierSelectNameSyntax")
        .def_readwrite("identifier", &IdentifierSelectNameSyntax::identifier)
        .def_readwrite("selectors", &IdentifierSelectNameSyntax::selectors);

    py::class_<EmptyIdentifierNameSyntax, NameSyntax>(m, "EmptyIdentifierNameSyntax")
        .def_readwrite("placeholder", &EmptyIdentifierNameSyntax::placeholder);

    py::class_<KeywordNameSyntax, NameSyntax>(m, "KeywordNameSyntax")
        .def_readwrite("keyword", &KeywordNameSyntax::keyword);

    py::class_<ClassNameSyntax, NameSyntax>(m, "ClassNameSyntax")
        .def_readwrite("identifier", &ClassNameSyntax::identifier)
        .def_readwrite("parameters", &ClassNameSyntax::parameters);

    py::class_<ScopedNameSyntax, NameSyntax>(m, "ScopedNameSyntax")
        .def_readwrite("left", &ScopedNameSyntax::left)
        .def_readwrite("separator", &ScopedNameSyntax::separator)
        .def_readwrite("right", &ScopedNameSyntax::right);

    py::class_<LiteralExpressionSyntax, PrimaryExpressionSyntax>(m, "LiteralExpressionSyntax")
        .def_readwrite("literal", &LiteralExpressionSyntax::literal);

    py::class_<IntegerVectorExpressionSyntax, PrimaryExpressionSyntax>(m, "IntegerVectorExpressionSyntax")
        .def_readwrite("size", &IntegerVectorExpressionSyntax::size)
        .def_readwrite("base", &IntegerVectorExpressionSyntax::base)
        .def_readwrite("value", &IntegerVectorExpressionSyntax::value);

    py::class_<EmptyQueueExpressionSyntax, PrimaryExpressionSyntax>(m, "EmptyQueueExpressionSyntax")
        .def_readwrite("openBrace", &EmptyQueueExpressionSyntax::openBrace)
        .def_readwrite("closeBrace", &EmptyQueueExpressionSyntax::closeBrace);

    py::class_<ConcatenationExpressionSyntax, PrimaryExpressionSyntax>(m, "ConcatenationExpressionSyntax")
        .def_readwrite("openBrace", &ConcatenationExpressionSyntax::openBrace)
        .def_readwrite("expressions", &ConcatenationExpressionSyntax::expressions)
        .def_readwrite("closeBrace", &ConcatenationExpressionSyntax::closeBrace);

    py::class_<MultipleConcatenationExpressionSyntax, PrimaryExpressionSyntax>(m, "MultipleConcatenationExpressionSyntax")
        .def_readwrite("openBrace", &MultipleConcatenationExpressionSyntax::openBrace)
        .def_readwrite("expression", &MultipleConcatenationExpressionSyntax::expression)
        .def_readwrite("concatenation", &MultipleConcatenationExpressionSyntax::concatenation)
        .def_readwrite("closeBrace", &MultipleConcatenationExpressionSyntax::closeBrace);

    py::class_<StreamExpressionWithRangeSyntax, SyntaxNode>(m, "StreamExpressionWithRangeSyntax")
        .def_readwrite("withKeyword", &StreamExpressionWithRangeSyntax::withKeyword)
        .def_readwrite("range", &StreamExpressionWithRangeSyntax::range);

    py::class_<StreamExpressionSyntax, SyntaxNode>(m, "StreamExpressionSyntax")
        .def_readwrite("expression", &StreamExpressionSyntax::expression)
        .def_readwrite("withRange", &StreamExpressionSyntax::withRange);

    py::class_<StreamingConcatenationExpressionSyntax, PrimaryExpressionSyntax>(m, "StreamingConcatenationExpressionSyntax")
        .def_readwrite("openBrace", &StreamingConcatenationExpressionSyntax::openBrace)
        .def_readwrite("operatorToken", &StreamingConcatenationExpressionSyntax::operatorToken)
        .def_readwrite("sliceSize", &StreamingConcatenationExpressionSyntax::sliceSize)
        .def_readwrite("innerOpenBrace", &StreamingConcatenationExpressionSyntax::innerOpenBrace)
        .def_readwrite("expressions", &StreamingConcatenationExpressionSyntax::expressions)
        .def_readwrite("innerCloseBrace", &StreamingConcatenationExpressionSyntax::innerCloseBrace)
        .def_readwrite("closeBrace", &StreamingConcatenationExpressionSyntax::closeBrace);

    py::class_<ParenthesizedExpressionSyntax, PrimaryExpressionSyntax>(m, "ParenthesizedExpressionSyntax")
        .def_readwrite("openParen", &ParenthesizedExpressionSyntax::openParen)
        .def_readwrite("expression", &ParenthesizedExpressionSyntax::expression)
        .def_readwrite("closeParen", &ParenthesizedExpressionSyntax::closeParen);

    py::class_<NewArrayExpressionSyntax, ExpressionSyntax>(m, "NewArrayExpressionSyntax")
        .def_readwrite("newKeyword", &NewArrayExpressionSyntax::newKeyword)
        .def_readwrite("openBracket", &NewArrayExpressionSyntax::openBracket)
        .def_readwrite("sizeExpr", &NewArrayExpressionSyntax::sizeExpr)
        .def_readwrite("closeBracket", &NewArrayExpressionSyntax::closeBracket)
        .def_readwrite("initializer", &NewArrayExpressionSyntax::initializer);

    py::class_<NewClassExpressionSyntax, ExpressionSyntax>(m, "NewClassExpressionSyntax")
        .def_readwrite("scopedNew", &NewClassExpressionSyntax::scopedNew)
        .def_readwrite("argList", &NewClassExpressionSyntax::argList);

    py::class_<CopyClassExpressionSyntax, ExpressionSyntax>(m, "CopyClassExpressionSyntax")
        .def_readwrite("scopedNew", &CopyClassExpressionSyntax::scopedNew)
        .def_readwrite("expr", &CopyClassExpressionSyntax::expr);

    py::class_<SuperNewDefaultedArgsExpressionSyntax, ExpressionSyntax>(m, "SuperNewDefaultedArgsExpressionSyntax")
        .def_readwrite("scopedNew", &SuperNewDefaultedArgsExpressionSyntax::scopedNew)
        .def_readwrite("openParen", &SuperNewDefaultedArgsExpressionSyntax::openParen)
        .def_readwrite("defaultKeyword", &SuperNewDefaultedArgsExpressionSyntax::defaultKeyword)
        .def_readwrite("closeParen", &SuperNewDefaultedArgsExpressionSyntax::closeParen);

    py::class_<ElementSelectExpressionSyntax, ExpressionSyntax>(m, "ElementSelectExpressionSyntax")
        .def_readwrite("left", &ElementSelectExpressionSyntax::left)
        .def_readwrite("select", &ElementSelectExpressionSyntax::select);

    py::class_<MemberAccessExpressionSyntax, ExpressionSyntax>(m, "MemberAccessExpressionSyntax")
        .def_readwrite("left", &MemberAccessExpressionSyntax::left)
        .def_readwrite("dot", &MemberAccessExpressionSyntax::dot)
        .def_readwrite("name", &MemberAccessExpressionSyntax::name);

    py::class_<InvocationExpressionSyntax, ExpressionSyntax>(m, "InvocationExpressionSyntax")
        .def_readwrite("left", &InvocationExpressionSyntax::left)
        .def_readwrite("attributes", &InvocationExpressionSyntax::attributes)
        .def_readwrite("arguments", &InvocationExpressionSyntax::arguments);

    py::class_<CastExpressionSyntax, ExpressionSyntax>(m, "CastExpressionSyntax")
        .def_readwrite("left", &CastExpressionSyntax::left)
        .def_readwrite("apostrophe", &CastExpressionSyntax::apostrophe)
        .def_readwrite("right", &CastExpressionSyntax::right);

    py::class_<SignedCastExpressionSyntax, ExpressionSyntax>(m, "SignedCastExpressionSyntax")
        .def_readwrite("signing", &SignedCastExpressionSyntax::signing)
        .def_readwrite("apostrophe", &SignedCastExpressionSyntax::apostrophe)
        .def_readwrite("inner", &SignedCastExpressionSyntax::inner);

    py::class_<DelaySyntax, TimingControlSyntax>(m, "DelaySyntax")
        .def_readwrite("hash", &DelaySyntax::hash)
        .def_readwrite("delayValue", &DelaySyntax::delayValue);

    py::class_<Delay3Syntax, TimingControlSyntax>(m, "Delay3Syntax")
        .def_readwrite("hash", &Delay3Syntax::hash)
        .def_readwrite("openParen", &Delay3Syntax::openParen)
        .def_readwrite("delay1", &Delay3Syntax::delay1)
        .def_readwrite("comma1", &Delay3Syntax::comma1)
        .def_readwrite("delay2", &Delay3Syntax::delay2)
        .def_readwrite("comma2", &Delay3Syntax::comma2)
        .def_readwrite("delay3", &Delay3Syntax::delay3)
        .def_readwrite("closeParen", &Delay3Syntax::closeParen);

    py::class_<OneStepDelaySyntax, TimingControlSyntax>(m, "OneStepDelaySyntax")
        .def_readwrite("hash", &OneStepDelaySyntax::hash)
        .def_readwrite("oneStep", &OneStepDelaySyntax::oneStep);

    py::class_<EventControlSyntax, TimingControlSyntax>(m, "EventControlSyntax")
        .def_readwrite("at", &EventControlSyntax::at)
        .def_readwrite("eventName", &EventControlSyntax::eventName);

    py::class_<IffEventClauseSyntax, SyntaxNode>(m, "IffEventClauseSyntax")
        .def_readwrite("iff", &IffEventClauseSyntax::iff)
        .def_readwrite("expr", &IffEventClauseSyntax::expr);

    py::class_<EventExpressionSyntax, SequenceExprSyntax>(m, "EventExpressionSyntax");

    py::class_<SignalEventExpressionSyntax, EventExpressionSyntax>(m, "SignalEventExpressionSyntax")
        .def_readwrite("edge", &SignalEventExpressionSyntax::edge)
        .def_readwrite("expr", &SignalEventExpressionSyntax::expr)
        .def_readwrite("iffClause", &SignalEventExpressionSyntax::iffClause);

    py::class_<BinaryEventExpressionSyntax, EventExpressionSyntax>(m, "BinaryEventExpressionSyntax")
        .def_readwrite("left", &BinaryEventExpressionSyntax::left)
        .def_readwrite("operatorToken", &BinaryEventExpressionSyntax::operatorToken)
        .def_readwrite("right", &BinaryEventExpressionSyntax::right);

    py::class_<ParenthesizedEventExpressionSyntax, EventExpressionSyntax>(m, "ParenthesizedEventExpressionSyntax")
        .def_readwrite("openParen", &ParenthesizedEventExpressionSyntax::openParen)
        .def_readwrite("expr", &ParenthesizedEventExpressionSyntax::expr)
        .def_readwrite("closeParen", &ParenthesizedEventExpressionSyntax::closeParen);

    py::class_<ImplicitEventControlSyntax, TimingControlSyntax>(m, "ImplicitEventControlSyntax")
        .def_readwrite("at", &ImplicitEventControlSyntax::at)
        .def_readwrite("openParen", &ImplicitEventControlSyntax::openParen)
        .def_readwrite("star", &ImplicitEventControlSyntax::star)
        .def_readwrite("closeParen", &ImplicitEventControlSyntax::closeParen);

    py::class_<EventControlWithExpressionSyntax, TimingControlSyntax>(m, "EventControlWithExpressionSyntax")
        .def_readwrite("at", &EventControlWithExpressionSyntax::at)
        .def_readwrite("expr", &EventControlWithExpressionSyntax::expr);

    py::class_<RepeatedEventControlSyntax, TimingControlSyntax>(m, "RepeatedEventControlSyntax")
        .def_readwrite("repeat", &RepeatedEventControlSyntax::repeat)
        .def_readwrite("openParen", &RepeatedEventControlSyntax::openParen)
        .def_readwrite("expr", &RepeatedEventControlSyntax::expr)
        .def_readwrite("closeParen", &RepeatedEventControlSyntax::closeParen)
        .def_readwrite("eventControl", &RepeatedEventControlSyntax::eventControl);

    py::class_<TimingControlExpressionSyntax, ExpressionSyntax>(m, "TimingControlExpressionSyntax")
        .def_readwrite("timing", &TimingControlExpressionSyntax::timing)
        .def_readwrite("expr", &TimingControlExpressionSyntax::expr);

    py::class_<DimensionSpecifierSyntax, SyntaxNode>(m, "DimensionSpecifierSyntax");

    py::class_<RangeDimensionSpecifierSyntax, DimensionSpecifierSyntax>(m, "RangeDimensionSpecifierSyntax")
        .def_readwrite("selector", &RangeDimensionSpecifierSyntax::selector);

    py::class_<WildcardDimensionSpecifierSyntax, DimensionSpecifierSyntax>(m, "WildcardDimensionSpecifierSyntax")
        .def_readwrite("star", &WildcardDimensionSpecifierSyntax::star);

    py::class_<ColonExpressionClauseSyntax, SyntaxNode>(m, "ColonExpressionClauseSyntax")
        .def_readwrite("colon", &ColonExpressionClauseSyntax::colon)
        .def_readwrite("expr", &ColonExpressionClauseSyntax::expr);

    py::class_<QueueDimensionSpecifierSyntax, DimensionSpecifierSyntax>(m, "QueueDimensionSpecifierSyntax")
        .def_readwrite("dollar", &QueueDimensionSpecifierSyntax::dollar)
        .def_readwrite("maxSizeClause", &QueueDimensionSpecifierSyntax::maxSizeClause);

    py::class_<VariableDimensionSyntax, SyntaxNode>(m, "VariableDimensionSyntax")
        .def_readwrite("openBracket", &VariableDimensionSyntax::openBracket)
        .def_readwrite("specifier", &VariableDimensionSyntax::specifier)
        .def_readwrite("closeBracket", &VariableDimensionSyntax::closeBracket);

    py::class_<DeclaratorSyntax, SyntaxNode>(m, "DeclaratorSyntax")
        .def_readwrite("name", &DeclaratorSyntax::name)
        .def_readwrite("dimensions", &DeclaratorSyntax::dimensions)
        .def_readwrite("initializer", &DeclaratorSyntax::initializer);

    py::class_<DataDeclarationSyntax, MemberSyntax>(m, "DataDeclarationSyntax")
        .def_readwrite("modifiers", &DataDeclarationSyntax::modifiers)
        .def_readwrite("type", &DataDeclarationSyntax::type)
        .def_readwrite("declarators", &DataDeclarationSyntax::declarators)
        .def_readwrite("semi", &DataDeclarationSyntax::semi);

    py::class_<ForwardTypeRestrictionSyntax, SyntaxNode>(m, "ForwardTypeRestrictionSyntax")
        .def_readwrite("keyword1", &ForwardTypeRestrictionSyntax::keyword1)
        .def_readwrite("keyword2", &ForwardTypeRestrictionSyntax::keyword2);

    py::class_<TypedefDeclarationSyntax, MemberSyntax>(m, "TypedefDeclarationSyntax")
        .def_readwrite("typedefKeyword", &TypedefDeclarationSyntax::typedefKeyword)
        .def_readwrite("type", &TypedefDeclarationSyntax::type)
        .def_readwrite("name", &TypedefDeclarationSyntax::name)
        .def_readwrite("dimensions", &TypedefDeclarationSyntax::dimensions)
        .def_readwrite("semi", &TypedefDeclarationSyntax::semi);

    py::class_<ForwardTypedefDeclarationSyntax, MemberSyntax>(m, "ForwardTypedefDeclarationSyntax")
        .def_readwrite("typedefKeyword", &ForwardTypedefDeclarationSyntax::typedefKeyword)
        .def_readwrite("typeRestriction", &ForwardTypedefDeclarationSyntax::typeRestriction)
        .def_readwrite("name", &ForwardTypedefDeclarationSyntax::name)
        .def_readwrite("semi", &ForwardTypedefDeclarationSyntax::semi);

    py::class_<NetStrengthSyntax, SyntaxNode>(m, "NetStrengthSyntax");

    py::class_<ChargeStrengthSyntax, NetStrengthSyntax>(m, "ChargeStrengthSyntax")
        .def_readwrite("openParen", &ChargeStrengthSyntax::openParen)
        .def_readwrite("strength", &ChargeStrengthSyntax::strength)
        .def_readwrite("closeParen", &ChargeStrengthSyntax::closeParen);

    py::class_<DriveStrengthSyntax, NetStrengthSyntax>(m, "DriveStrengthSyntax")
        .def_readwrite("openParen", &DriveStrengthSyntax::openParen)
        .def_readwrite("strength0", &DriveStrengthSyntax::strength0)
        .def_readwrite("comma", &DriveStrengthSyntax::comma)
        .def_readwrite("strength1", &DriveStrengthSyntax::strength1)
        .def_readwrite("closeParen", &DriveStrengthSyntax::closeParen);

    py::class_<PullStrengthSyntax, NetStrengthSyntax>(m, "PullStrengthSyntax")
        .def_readwrite("openParen", &PullStrengthSyntax::openParen)
        .def_readwrite("strength", &PullStrengthSyntax::strength)
        .def_readwrite("closeParen", &PullStrengthSyntax::closeParen);

}
